import Conductor from 'conductor-node';
const conductor = new Conductor({
apiKey: process.env['CONDUCTOR_SECRET_KEY'], // This is the default and can be omitted
});
// Automatically fetches more pages as needed.
for await (const customer of conductor.qbd.customers.list({
conductorEndUserId: 'end_usr_1234567abcdefg',
})) {
console.log(customer.id);
}
import os
from conductor import Conductor
conductor = Conductor(
api_key=os.environ.get("CONDUCTOR_SECRET_KEY"), # This is the default and can be omitted
)
page = conductor.qbd.customers.list(
conductor_end_user_id="end_usr_1234567abcdefg",
)
page = page.data[0]
print(page.id)
Returns a list of customers. Use the cursor parameter to paginate through the results.
IMPORTANT: If this request times out or is slow, set excludeAlternateShippingAddresses=true to significantly improve performance. Use the cursor parameter to paginate through the results.
GET
/
quickbooks-desktop
/
customers
JavaScript
import Conductor from 'conductor-node';
const conductor = new Conductor({
apiKey: process.env['CONDUCTOR_SECRET_KEY'], // This is the default and can be omitted
});
// Automatically fetches more pages as needed.
for await (const customer of conductor.qbd.customers.list({
conductorEndUserId: 'end_usr_1234567abcdefg',
})) {
console.log(customer.id);
}
import os
from conductor import Conductor
conductor = Conductor(
api_key=os.environ.get("CONDUCTOR_SECRET_KEY"), # This is the default and can be omitted
)
page = conductor.qbd.customers.list(
conductor_end_user_id="end_usr_1234567abcdefg",
)
page = page.data[0]
print(page.id)
Filter for specific customers by their full-name(s), case-insensitive. Like id, fullName is a unique identifier for a customer, formed by by combining the names of its parent objects with its own name, separated by colons. For example, if a customer is under "ABC Corporation" and has the name "Website Redesign Project", its fullName would be "ABC Corporation:Website Redesign Project".
IMPORTANT: If you include this parameter, QuickBooks will ignore all other query parameters for this request.
NOTE: If any of the values you specify in this parameter are not found, the request will return an error.
The maximum number of objects to return. Accepts values ranging from 1 to 150, defaults to 150. When used with cursor-based pagination, this parameter controls how many results are returned per page. To paginate through results, combine this with the cursor parameter. Each response will include a nextCursor value that can be passed to subsequent requests to retrieve the next page of results.
The pagination token to fetch the next set of results when paginating with the limit parameter. Do not include this parameter on the first call. Use the nextCursor value returned in the previous response to request subsequent results.
IMPORTANT: The cursor is the same value for every page, and requests that send it are not idempotent: each one returns the next page. Send each request within 10 seconds of the previous response. If you miss that window or a request fails, start over without a cursor. To make a run resumable, see Paging by name.
Filter for customers updated on or after this date/time. Accepts the following ISO 8601 formats:
date-only (YYYY-MM-DD) - QuickBooks Desktop interprets the date as the start of the specified day in the local timezone of the end-user's computer (e.g., 2025-01-01 → 2025-01-01T00:00:00).
datetime without timezone (YYYY-MM-DDTHH:mm:ss) - QuickBooks Desktop interprets the timestamp in the local timezone of the end-user's computer.
datetime with timezone (YYYY-MM-DDTHH:mm:ss±HH:mm) - QuickBooks Desktop interprets the timestamp using the specified timezone.
Filter for customers updated on or before this date/time. Accepts the following ISO 8601 formats:
date-only (YYYY-MM-DD) - QuickBooks Desktop interprets the date as the end of the specified day in the local timezone of the end-user's computer (e.g., 2025-01-01 → 2025-01-01T23:59:59).
datetime without timezone (YYYY-MM-DDTHH:mm:ss) - QuickBooks Desktop interprets the timestamp in the local timezone of the end-user's computer.
datetime with timezone (YYYY-MM-DDTHH:mm:ss±HH:mm) - QuickBooks Desktop interprets the timestamp using the specified timezone.
Filter for customers whose fullName sorts at or after this value (inclusive), compared case-insensitively in QuickBooks' sort order: punctuation first, then digits, then letters.
When you set nameFrom or nameTo, QuickBooks returns customers sorted by fullName in that order; without either, the order is not guaranteed. To page through customers by name, see Paging by name.
NOTE: If you use this parameter, you cannot also use nameContains, nameStartsWith, or nameEndsWith.
Filter for customers whose fullName sorts at or before this value (inclusive), compared case-insensitively in QuickBooks' sort order: punctuation first, then digits, then letters. If you also set nameFrom, it must not sort after this value, or QuickBooks returns an error.
When you set nameFrom or nameTo, QuickBooks returns customers sorted by fullName in that order; without either, the order is not guaranteed.
NOTE: If you use this parameter, you cannot also use nameContains, nameStartsWith, or nameEndsWith.
Filter for customers whose totalBalance is greater than this amount, represented as a decimal string. You can only use one total-balance filter at a time.
Filter for customers whose totalBalance is greater than or equal to this amount, represented as a decimal string. You can only use one total-balance filter at a time.
Filter for customers whose totalBalance is less than this amount, represented as a decimal string. You can only use one total-balance filter at a time.
Filter for customers whose totalBalance is less than or equal to this amount, represented as a decimal string. You can only use one total-balance filter at a time.
Excludes alternate shipping addresses from each customer returned by the list request. When true, the response returns alternateShippingAddresses as null instead of fetching the address array. Use this when your integration does not need alternate shipping addresses. This significantly improves performance for company files where some customers have many saved shipping addresses (sometimes dozens or hundreds).
The nextCursor is a pagination token returned in the response when you use the limit parameter in your request. To retrieve subsequent pages of results, include this token as the value of the cursor request parameter in your following API calls.
NOTE: The nextCursor value remains constant throughout the pagination process for a specific list instance; continue to use the same nextCursor token in each request to fetch additional pages.
Indicates whether there are more objects to be fetched.
{"docsConfig":{"theme":"mint","$schema":"https://mintlify.com/docs.json","name":"Conductor Docs","colors":{"primary":"#9563FF","light":"#AE87FF","dark":"#0D001D"},"logo":{"light":"https://mintcdn.com/conductor/hjDC6C2Dz4sn63AO/logo/light.png?fit=max\u0026auto=format\u0026n=hjDC6C2Dz4sn63AO\u0026q=85\u0026s=43ebf17eb46ef6256a508d4fac23b3bf","dark":"https://mintcdn.com/conductor/hjDC6C2Dz4sn63AO/logo/dark.png?fit=max\u0026auto=format\u0026n=hjDC6C2Dz4sn63AO\u0026q=85\u0026s=dbd4c90195fb31cbae682dd4bfb98350","href":"https://conductor.is"},"favicon":"https://mintcdn.com/conductor/79gIlu1T1D-ycZhm/favicon.png?fit=max\u0026auto=format\u0026n=79gIlu1T1D-ycZhm\u0026q=85\u0026s=52c2193ef1a37fb3c2a843f148178e26","api":{"openapi":"openapi.documented.yml","playground":{"display":"interactive"}},"background":{"color":{"dark":"#090014"}},"navbar":{"links":[{"href":"mailto:support@conductor.is?subject=Conductor Help","label":"Support"},{"href":"https://dashboard.conductor.is","label":"Dashboard"}],"primary":{"type":"button","label":"Sign up","href":"https://dashboard.conductor.is/sign-up"}},"footer":{"socials":{"twitter":"https://twitter.com/conductor_is","github":"https://github.com/conductor-is","linkedin":"https://linkedin.com/company/conductor-is"},"links":[{"header":"Product","items":[{"label":"Core","href":"https://conductor.is/"},{"label":"FAQ","href":"https://docs.conductor.is/faq"},{"label":"Security","href":"https://docs.conductor.is/security"},{"label":"Testimonials","href":"https://conductor.is/"},{"label":"Pricing","href":"https://conductor.is/"}]},{"header":"Resources","items":[{"label":"Documentation","href":"https://docs.conductor.is"},{"label":"Help Center","href":"https://docs.conductor.is/help"},{"label":"Status","href":"https://status.conductor.is"},{"label":"Quickstart","href":"https://docs.conductor.is/quickstart"}]},{"header":"Company","items":[{"label":"About","href":"https://conductor.is/company"},{"label":"Values","href":"https://conductor-io.notion.site/Conductor-s-Values-83e9eb6e4e4d40a2973b24513dc60f99?pvs=4"},{"label":"Contact","href":"mailto:support@conductor.is?subject=Conductor Help"}]},{"header":"Legal","items":[{"label":"Privacy Policy","href":"https://conductor.is/privacy"},{"label":"Terms of Service","href":"https://conductor.is/terms"},{"label":"Trust Center","href":"https://trust.conductor.is"}]}]},"styling":{"codeblocks":"system","latex":false},"integrations":{"ga4":{"measurementId":"G-X8MDB0LXNF"}},"contextual":{"options":["copy","view","chatgpt","claude"],"display":"header"},"navigation":{"pages":[]}},"deployment":{"deploymentMetadataValue":{"subdomain":"conductor","hasAudioNarration":false,"actualSubdomain":"conductor","customDomains":["docs.conductor.is"],"gitSource":{"type":"github","owner":"conductor-is","repo":"conductor","deployBranch":"main","contentDirectory":"apps/docs","isPrivate":false,"mountPath":"","label":""},"chroma":{"liveDeploymentHistoryId":"6ae042c6cfb66ba7c5e7468e","collectionId":"66eb598f-c993-4e40-b07a-4b04e5a88607","schemaVersion":"v3","latestBuiltDeploymentHistoryId":"6ae042c6cfb66ba7c5e7468e"},"feedback":{"edits":false},"entitlements":{"AI_CHAT":{"status":"ENABLED"},"WEB_MCP":{"status":"ENABLED"},"NARRATION":{"status":"ENABLED"}},"buildId":"6ae0df04db357e3cc45a0c3c","clientVersion":"0.0.3971","searchFilterCounts":[{"language":"default","tag":"API Reference","count":337},{"language":"default","tag":"Transactions","count":160},{"language":"default","tag":"General","count":104},{"language":"default","tag":"Items","count":53},{"language":"default","tag":"Help","count":25},{"language":"default","tag":"Documentation","count":15},{"language":"default","tag":"Guides","count":14},{"language":"default","tag":"Reports","count":11},{"language":"default","tag":"QuickBooks Desktop API","count":10},{"language":"default","tag":"Connection errors","count":9}]},"assistantConfig":{},"basePath":"","hasChatPermissions":true,"hasWebMcpPermissions":true,"toggles":[{"name":"kill-isr","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-mintlify-slack","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-v7-file-tree","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-integrations-settings","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-pr-grouping","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"custom-prefix","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"analytics-v7","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"user-flows-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"no-publish-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-onboarding","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"llms-txt-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"pause-universal-search-reconcile","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving-live","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"stripTemperatureMiddleware","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"per-site-search-delta","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"support-platform-pylon-zendesk","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"instant-rollback","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications-server","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-private-page-search","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-fable","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fixed-ai-action-pricing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automation-resolve-merge-conflict","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"scoped-publishing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"mintql","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"page-level-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-version-history-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-nav-generations","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-page-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workspace-projects","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"assistant-v5","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"byok-sep-25","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fork-pr-previews","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"revalidation-jwt","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"vite-origin","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-agent-model-picker","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-updated-9-15","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-sso-scim","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"hobby-abuse-scan","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"dashboard-inbox","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-signup","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-enabled","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false}],"isAtlas":false,"googleFontsInlined":false},"customCss":[],"page":{"pagePath":"api-ref/qbd/customers/list","slug":"/api-ref/qbd/customers/list","pageMetadata":{"openapi":"GET /quickbooks-desktop/customers","title":"List all customers","description":"Returns a list of customers. Use the `cursor` parameter to paginate through the results.\n\n**IMPORTANT**: If this request times out or is slow, set `excludeAlternateShippingAddresses=true` to significantly improve performance. Use the `cursor` parameter to paginate through the results.","href":"/api-ref/qbd/customers/list"},"description":{"compiledSource":"\"use strict\";\nconst {Fragment: _Fragment, jsx: _jsx, jsxs: _jsxs} = arguments[0];\nconst {useMDXComponents: _provideComponents} = arguments[0];\nfunction _createMdxContent(props) {\n const _components = {\n code: \"code\",\n p: \"p\",\n strong: \"strong\",\n ..._provideComponents(),\n ...props.components\n };\n return _jsxs(_Fragment, {\n children: [_jsxs(_components.p, {\n children: [\"Returns a list of customers. Use the \", _jsx(_components.code, {\n children: \"cursor\"\n }), \" parameter to paginate through the results.\"]\n }), \"\\n\", _jsxs(_components.p, {\n children: [_jsx(_components.strong, {\n children: \"IMPORTANT\"\n }), \": If this request times out or is slow, set \", _jsx(_components.code, {\n children: \"excludeAlternateShippingAddresses=true\"\n }), \" to significantly improve performance. Use the \", _jsx(_components.code, {\n children: \"cursor\"\n }), \" parameter to paginate through the results.\"]\n })]\n });\n}\nfunction MDXContent(props = {}) {\n const {wrapper: MDXLayout} = {\n ..._provideComponents(),\n ...props.components\n };\n return MDXLayout ? _jsx(MDXLayout, {\n ...props,\n children: _jsx(_createMdxContent, {\n ...props\n })\n }) : _createMdxContent(props);\n}\nreturn {\n default: MDXContent\n};\n","frontmatter":{},"scope":{}},"pageType":"default","mdx":{"mdxSource":{"compiledSource":"\"use strict\";const{Fragment:_Fragment,jsx:_jsx}=arguments[0];const{useMDXComponents:_provideComponents}=arguments[0];function _createMdxContent(props){return _jsx(_Fragment,{})}function MDXContent(props={}){const{wrapper:MDXLayout}={..._provideComponents(),...props.components};return MDXLayout?_jsx(MDXLayout,{...props,children:_jsx(_createMdxContent,{...props})}):_createMdxContent(props)}return{default:MDXContent}","frontmatter":{},"scope":{"codeStyling":"system","config":{},"pageMetadata":{"openapi":"GET /quickbooks-desktop/customers","title":"List all customers","description":"Returns a list of customers. Use the `cursor` parameter to paginate through the results.\n\n**IMPORTANT**: If this request times out or is slow, set `excludeAlternateShippingAddresses=true` to significantly improve performance. Use the `cursor` parameter to paginate through the results.","href":"/api-ref/qbd/customers/list"}}},"mdxSourceWithNoJs":null},"mdxExtracts":{"tableOfContents":[],"codeExamples":{}},"jsLinks":[],"openApiReferenceData":{"operation":{"summary":"List all customers","description":"Returns a list of customers. Use the `cursor` parameter to paginate through the results.\n\n**IMPORTANT**: If this request times out or is slow, set `excludeAlternateShippingAddresses=true` to significantly improve performance. Use the `cursor` parameter to paginate through the results.","security":["2a772966-9bed-4c2d-8851-adbbff7091c8"],"parameters":["10c2239a-9cab-4fa6-ac19-d409b142a2b1","d0fc8bd7-99cd-49a4-9451-f264f0a8bd3a","d5f8462e-da4e-4070-bf8c-1ee77d1f108f","fd742ad7-92de-4344-8f72-19f2594ae68e","009eb4ca-6c2c-40d7-b704-85dcb14fe5f6","4a442097-3e6f-4234-9a1d-b77f83692d37","1e8cb352-6ce1-45e6-ba84-1809eafd50a9","c6f7d2ee-57f6-46b5-b71f-fb4763d2da61","31c5fabd-11c8-4cbf-b16f-ba6ceed47a6f","74c4535f-8f36-4f8a-a6b0-3e8895fe0da5","24be27c9-cc70-4c27-be9b-f7abafd31316","16278bd0-8cad-4b9d-afdf-58b5bd679abf","bfb5cc62-2dfb-4fc5-877e-a3cf1557ba93","fa1e8180-9cb3-4380-a380-6537dc490808","8965f908-c1ff-48be-a41d-e80e30235c2f","2726e494-bfd3-468f-98ce-1b315c038fbb","b2b94255-8ac5-42c5-8aa3-639304249c6f","16474042-3ca9-4ca4-b679-09041c9b95c9","8f1a5307-18f1-44de-8348-b4b870283a3a","f0208591-1454-4058-87b5-423fc58f268d","9bfbf1b6-a15a-4a3c-a364-adea056217a2"],"responses":{"200":"cdf11b4c-8269-44b4-b4ff-2561daba0688"},"x-codeSamples":[{"lang":"JavaScript","source":"import Conductor from 'conductor-node';\n\nconst conductor = new Conductor({\n apiKey: process.env['CONDUCTOR_SECRET_KEY'], // This is the default and can be omitted\n});\n\n// Automatically fetches more pages as needed.\nfor await (const customer of conductor.qbd.customers.list({\n conductorEndUserId: 'end_usr_1234567abcdefg',\n})) {\n console.log(customer.id);\n}"},{"lang":"Python","source":"import os\nfrom conductor import Conductor\n\nconductor = Conductor(\n api_key=os.environ.get(\"CONDUCTOR_SECRET_KEY\"), # This is the default and can be omitted\n)\npage = conductor.qbd.customers.list(\n conductor_end_user_id=\"end_usr_1234567abcdefg\",\n)\npage = page.data[0]\nprint(page.id)"}],"method":"get","type":"path","servers":["045cea4d-dfb6-46e4-9c51-52452b7b239b"],"path":"/quickbooks-desktop/customers","baseUrlOptions":["https://api.conductor.is/v1"],"title":"List all customers","codeSamples":[{"lang":"JavaScript","source":"import Conductor from 'conductor-node';\n\nconst conductor = new Conductor({\n apiKey: process.env['CONDUCTOR_SECRET_KEY'], // This is the default and can be omitted\n});\n\n// Automatically fetches more pages as needed.\nfor await (const customer of conductor.qbd.customers.list({\n conductorEndUserId: 'end_usr_1234567abcdefg',\n})) {\n console.log(customer.id);\n}"},{"lang":"Python","source":"import os\nfrom conductor import Conductor\n\nconductor = Conductor(\n api_key=os.environ.get(\"CONDUCTOR_SECRET_KEY\"), # This is the default and can be omitted\n)\npage = conductor.qbd.customers.list(\n conductor_end_user_id=\"end_usr_1234567abcdefg\",\n)\npage = page.data[0]\nprint(page.id)"}],"requiredOnlyExamples":false,"requestExampleType":"codeSamples","responseExampleType":"generated"},"dependencies":{"parameters":{"10c2239a-9cab-4fa6-ac19-d409b142a2b1":{"in":"header","name":"Conductor-End-User-Id","schema":{"type":"string","description":"The ID of the End-User to receive this request.","example":"end_usr_1234567abcdefg","x-stainless-naming":{"typescript":{"method_argument":"conductorEndUserId"},"mcp":{"method_argument":"conductorEndUserId"}},"isRequired":true,"uniqueKey":"","typeLabel":"string"},"required":true,"description":"The ID of the End-User to receive this request."},"d0fc8bd7-99cd-49a4-9451-f264f0a8bd3a":{"in":"query","name":"ids","schema":{"description":"Filter for specific customers by their QuickBooks-assigned unique identifier(s).\n\n**IMPORTANT**: If you include this parameter, QuickBooks will ignore all other query parameters for this request.\n\n**NOTE**: If any of the values you specify in this parameter are not found, the request will return an error.","example":["80000001-1234567890"],"type":"array","items":{"type":"string","uniqueKey":"items.[INDEX]","typeLabel":"string"},"uniqueKey":"","typeLabel":"string[]"},"description":"Filter for specific customers by their QuickBooks-assigned unique identifier(s).\n\n**IMPORTANT**: If you include this parameter, QuickBooks will ignore all other query parameters for this request.\n\n**NOTE**: If any of the values you specify in this parameter are not found, the request will return an error."},"d5f8462e-da4e-4070-bf8c-1ee77d1f108f":{"in":"query","name":"fullNames","schema":{"description":"Filter for specific customers by their full-name(s), case-insensitive. Like `id`, `fullName` is a unique identifier for a customer, formed by by combining the names of its parent objects with its own `name`, separated by colons. For example, if a customer is under \"ABC Corporation\" and has the `name` \"Website Redesign Project\", its `fullName` would be \"ABC Corporation:Website Redesign Project\".\n\n**IMPORTANT**: If you include this parameter, QuickBooks will ignore all other query parameters for this request.\n\n**NOTE**: If any of the values you specify in this parameter are not found, the request will return an error.","example":["ABC Corporation:Website Redesign Project"],"type":"array","items":{"type":"string","uniqueKey":"items.[INDEX]","typeLabel":"string"},"uniqueKey":"","typeLabel":"string[]"},"description":"Filter for specific customers by their full-name(s), case-insensitive. Like `id`, `fullName` is a unique identifier for a customer, formed by by combining the names of its parent objects with its own `name`, separated by colons. For example, if a customer is under \"ABC Corporation\" and has the `name` \"Website Redesign Project\", its `fullName` would be \"ABC Corporation:Website Redesign Project\".\n\n**IMPORTANT**: If you include this parameter, QuickBooks will ignore all other query parameters for this request.\n\n**NOTE**: If any of the values you specify in this parameter are not found, the request will return an error."},"fd742ad7-92de-4344-8f72-19f2594ae68e":{"in":"query","name":"limit","schema":{"default":150,"description":"The maximum number of objects to return. Accepts values ranging from 1 to 150, defaults to 150. When used with cursor-based pagination, this parameter controls how many results are returned per page. To paginate through results, combine this with the `cursor` parameter. Each response will include a `nextCursor` value that can be passed to subsequent requests to retrieve the next page of results.","example":150,"type":"integer","minimum":1,"maximum":150,"uniqueKey":"","typeLabel":"integer"},"description":"The maximum number of objects to return. Accepts values ranging from 1 to 150, defaults to 150. When used with cursor-based pagination, this parameter controls how many results are returned per page. To paginate through results, combine this with the `cursor` parameter. Each response will include a `nextCursor` value that can be passed to subsequent requests to retrieve the next page of results."},"009eb4ca-6c2c-40d7-b704-85dcb14fe5f6":{"in":"query","name":"cursor","schema":{"description":"The pagination token to fetch the next set of results when paginating with the `limit` parameter. Do not include this parameter on the first call. Use the `nextCursor` value returned in the previous response to request subsequent results.\n\n**IMPORTANT**: The cursor is the same value for every page, and requests that send it are not idempotent: each one returns the next page. Send each request within 10 seconds of the previous response. If you miss that window or a request fails, start over without a cursor. To make a run resumable, see [Paging by name](https://docs.conductor.is/api-ref/pagination#paging-by-name).","example":"12345678-abcd-abcd-example-1234567890ab","type":"string","uniqueKey":"","typeLabel":"string"},"description":"The pagination token to fetch the next set of results when paginating with the `limit` parameter. Do not include this parameter on the first call. Use the `nextCursor` value returned in the previous response to request subsequent results.\n\n**IMPORTANT**: The cursor is the same value for every page, and requests that send it are not idempotent: each one returns the next page. Send each request within 10 seconds of the previous response. If you miss that window or a request fails, start over without a cursor. To make a run resumable, see [Paging by name](https://docs.conductor.is/api-ref/pagination#paging-by-name)."},"4a442097-3e6f-4234-9a1d-b77f83692d37":{"in":"query","name":"status","schema":{"description":"Filter for customers that are active, inactive, or both.","example":"active","type":"string","enum":["active","all","inactive"],"default":"active","uniqueKey":"","typeLabel":"enum\u003cstring>"},"description":"Filter for customers that are active, inactive, or both."},"1e8cb352-6ce1-45e6-ba84-1809eafd50a9":{"in":"query","name":"updatedAfter","schema":{"description":"Filter for customers updated on or after this date/time. Accepts the following ISO 8601 formats:\n- **date-only** (YYYY-MM-DD) - QuickBooks Desktop interprets the date as the **start of the specified day** in the local timezone of the end-user's computer (e.g., `2025-01-01` → `2025-01-01T00:00:00`).\n- **datetime without timezone** (YYYY-MM-DDTHH:mm:ss) - QuickBooks Desktop interprets the timestamp in the local timezone of the end-user's computer.\n- **datetime with timezone** (YYYY-MM-DDTHH:mm:ss±HH:mm) - QuickBooks Desktop interprets the timestamp using the specified timezone.","example":"2025-01-01T12:34:56.000Z","type":"string","uniqueKey":"","typeLabel":"string"},"description":"Filter for customers updated on or after this date/time. Accepts the following ISO 8601 formats:\n- **date-only** (YYYY-MM-DD) - QuickBooks Desktop interprets the date as the **start of the specified day** in the local timezone of the end-user's computer (e.g., `2025-01-01` → `2025-01-01T00:00:00`).\n- **datetime without timezone** (YYYY-MM-DDTHH:mm:ss) - QuickBooks Desktop interprets the timestamp in the local timezone of the end-user's computer.\n- **datetime with timezone** (YYYY-MM-DDTHH:mm:ss±HH:mm) - QuickBooks Desktop interprets the timestamp using the specified timezone."},"c6f7d2ee-57f6-46b5-b71f-fb4763d2da61":{"in":"query","name":"updatedBefore","schema":{"description":"Filter for customers updated on or before this date/time. Accepts the following ISO 8601 formats:\n- **date-only** (YYYY-MM-DD) - QuickBooks Desktop interprets the date as the **end of the specified day** in the local timezone of the end-user's computer (e.g., `2025-01-01` → `2025-01-01T23:59:59`).\n- **datetime without timezone** (YYYY-MM-DDTHH:mm:ss) - QuickBooks Desktop interprets the timestamp in the local timezone of the end-user's computer.\n- **datetime with timezone** (YYYY-MM-DDTHH:mm:ss±HH:mm) - QuickBooks Desktop interprets the timestamp using the specified timezone.","example":"2025-02-01T12:34:56.000Z","type":"string","uniqueKey":"","typeLabel":"string"},"description":"Filter for customers updated on or before this date/time. Accepts the following ISO 8601 formats:\n- **date-only** (YYYY-MM-DD) - QuickBooks Desktop interprets the date as the **end of the specified day** in the local timezone of the end-user's computer (e.g., `2025-01-01` → `2025-01-01T23:59:59`).\n- **datetime without timezone** (YYYY-MM-DDTHH:mm:ss) - QuickBooks Desktop interprets the timestamp in the local timezone of the end-user's computer.\n- **datetime with timezone** (YYYY-MM-DDTHH:mm:ss±HH:mm) - QuickBooks Desktop interprets the timestamp using the specified timezone."},"31c5fabd-11c8-4cbf-b16f-ba6ceed47a6f":{"in":"query","name":"nameContains","schema":{"description":"Filter for customers whose `name` contains this substring, case-insensitive.\n\n**NOTE**: If you use this parameter, you cannot also use `nameStartsWith` or `nameEndsWith`.","example":"ABC","type":"string","uniqueKey":"","typeLabel":"string"},"description":"Filter for customers whose `name` contains this substring, case-insensitive.\n\n**NOTE**: If you use this parameter, you cannot also use `nameStartsWith` or `nameEndsWith`."},"74c4535f-8f36-4f8a-a6b0-3e8895fe0da5":{"in":"query","name":"nameStartsWith","schema":{"description":"Filter for customers whose `name` starts with this substring, case-insensitive.\n\n**NOTE**: If you use this parameter, you cannot also use `nameContains` or `nameEndsWith`.","example":"ABC","type":"string","uniqueKey":"","typeLabel":"string"},"description":"Filter for customers whose `name` starts with this substring, case-insensitive.\n\n**NOTE**: If you use this parameter, you cannot also use `nameContains` or `nameEndsWith`."},"24be27c9-cc70-4c27-be9b-f7abafd31316":{"in":"query","name":"nameEndsWith","schema":{"description":"Filter for customers whose `name` ends with this substring, case-insensitive.\n\n**NOTE**: If you use this parameter, you cannot also use `nameContains` or `nameStartsWith`.","example":"ABC","type":"string","uniqueKey":"","typeLabel":"string"},"description":"Filter for customers whose `name` ends with this substring, case-insensitive.\n\n**NOTE**: If you use this parameter, you cannot also use `nameContains` or `nameStartsWith`."},"16278bd0-8cad-4b9d-afdf-58b5bd679abf":{"in":"query","name":"nameFrom","schema":{"description":"Filter for customers whose `fullName` sorts at or after this value (inclusive), compared case-insensitively in QuickBooks' sort order: punctuation first, then digits, then letters.\n\nWhen you set `nameFrom` or `nameTo`, QuickBooks returns customers sorted by `fullName` in that order; without either, the order is not guaranteed. To page through customers by name, see [Paging by name](https://docs.conductor.is/api-ref/pagination#paging-by-name).\n\n**NOTE**: If you use this parameter, you cannot also use `nameContains`, `nameStartsWith`, or `nameEndsWith`.","example":"A","type":"string","uniqueKey":"","typeLabel":"string"},"description":"Filter for customers whose `fullName` sorts at or after this value (inclusive), compared case-insensitively in QuickBooks' sort order: punctuation first, then digits, then letters.\n\nWhen you set `nameFrom` or `nameTo`, QuickBooks returns customers sorted by `fullName` in that order; without either, the order is not guaranteed. To page through customers by name, see [Paging by name](https://docs.conductor.is/api-ref/pagination#paging-by-name).\n\n**NOTE**: If you use this parameter, you cannot also use `nameContains`, `nameStartsWith`, or `nameEndsWith`."},"bfb5cc62-2dfb-4fc5-877e-a3cf1557ba93":{"in":"query","name":"nameTo","schema":{"description":"Filter for customers whose `fullName` sorts at or before this value (inclusive), compared case-insensitively in QuickBooks' sort order: punctuation first, then digits, then letters. If you also set `nameFrom`, it must not sort after this value, or QuickBooks returns an error.\n\nWhen you set `nameFrom` or `nameTo`, QuickBooks returns customers sorted by `fullName` in that order; without either, the order is not guaranteed.\n\n**NOTE**: If you use this parameter, you cannot also use `nameContains`, `nameStartsWith`, or `nameEndsWith`.","example":"Z","type":"string","uniqueKey":"","typeLabel":"string"},"description":"Filter for customers whose `fullName` sorts at or before this value (inclusive), compared case-insensitively in QuickBooks' sort order: punctuation first, then digits, then letters. If you also set `nameFrom`, it must not sort after this value, or QuickBooks returns an error.\n\nWhen you set `nameFrom` or `nameTo`, QuickBooks returns customers sorted by `fullName` in that order; without either, the order is not guaranteed.\n\n**NOTE**: If you use this parameter, you cannot also use `nameContains`, `nameStartsWith`, or `nameEndsWith`."},"fa1e8180-9cb3-4380-a380-6537dc490808":{"in":"query","name":"totalBalance","schema":{"description":"Filter for customers whose `totalBalance` equals this amount, represented as a decimal string. You can only use one total-balance filter at a time.","example":"123.45","type":"string","uniqueKey":"","typeLabel":"string"},"description":"Filter for customers whose `totalBalance` equals this amount, represented as a decimal string. You can only use one total-balance filter at a time."},"8965f908-c1ff-48be-a41d-e80e30235c2f":{"in":"query","name":"totalBalanceGreaterThan","schema":{"description":"Filter for customers whose `totalBalance` is greater than this amount, represented as a decimal string. You can only use one total-balance filter at a time.","example":"123.45","type":"string","uniqueKey":"","typeLabel":"string"},"description":"Filter for customers whose `totalBalance` is greater than this amount, represented as a decimal string. You can only use one total-balance filter at a time."},"2726e494-bfd3-468f-98ce-1b315c038fbb":{"in":"query","name":"totalBalanceGreaterThanOrEqualTo","schema":{"description":"Filter for customers whose `totalBalance` is greater than or equal to this amount, represented as a decimal string. You can only use one total-balance filter at a time.","example":"123.45","type":"string","uniqueKey":"","typeLabel":"string"},"description":"Filter for customers whose `totalBalance` is greater than or equal to this amount, represented as a decimal string. You can only use one total-balance filter at a time."},"b2b94255-8ac5-42c5-8aa3-639304249c6f":{"in":"query","name":"totalBalanceLessThan","schema":{"description":"Filter for customers whose `totalBalance` is less than this amount, represented as a decimal string. You can only use one total-balance filter at a time.","example":"123.45","type":"string","uniqueKey":"","typeLabel":"string"},"description":"Filter for customers whose `totalBalance` is less than this amount, represented as a decimal string. You can only use one total-balance filter at a time."},"16474042-3ca9-4ca4-b679-09041c9b95c9":{"in":"query","name":"totalBalanceLessThanOrEqualTo","schema":{"description":"Filter for customers whose `totalBalance` is less than or equal to this amount, represented as a decimal string. You can only use one total-balance filter at a time.","example":"123.45","type":"string","uniqueKey":"","typeLabel":"string"},"description":"Filter for customers whose `totalBalance` is less than or equal to this amount, represented as a decimal string. You can only use one total-balance filter at a time."},"8f1a5307-18f1-44de-8348-b4b870283a3a":{"in":"query","name":"currencyIds","schema":{"description":"Filter for customers in these currencies.","example":["80000001-1234567890"],"type":"array","items":{"type":"string","uniqueKey":"items.[INDEX]","typeLabel":"string"},"uniqueKey":"","typeLabel":"string[]"},"description":"Filter for customers in these currencies."},"f0208591-1454-4058-87b5-423fc58f268d":{"in":"query","name":"classIds","schema":{"description":"Filter for customers of these classes. A class is a way end-users can categorize customers in QuickBooks.","example":["80000001-1234567890"],"type":"array","items":{"type":"string","uniqueKey":"items.[INDEX]","typeLabel":"string"},"uniqueKey":"","typeLabel":"string[]"},"description":"Filter for customers of these classes. A class is a way end-users can categorize customers in QuickBooks."},"9bfbf1b6-a15a-4a3c-a364-adea056217a2":{"in":"query","name":"excludeAlternateShippingAddresses","schema":{"description":"Excludes alternate shipping addresses from each customer returned by the list request. When true, the response returns `alternateShippingAddresses` as `null` instead of fetching the address array. Use this when your integration does not need alternate shipping addresses. This significantly improves performance for company files where some customers have many saved shipping addresses (sometimes dozens or hundreds).","example":true,"type":"boolean","default":false,"uniqueKey":"","typeLabel":"boolean"},"description":"Excludes alternate shipping addresses from each customer returned by the list request. When true, the response returns `alternateShippingAddresses` as `null` instead of fetching the address array. Use this when your integration does not need alternate shipping addresses. This significantly improves performance for company files where some customers have many saved shipping addresses (sometimes dozens or hundreds)."}},"responses":{"cdf11b4c-8269-44b4-b4ff-2561daba0688":{"description":"Returns a list of customers.","headers":{"Conductor-Request-Id":{"required":true,"description":"The unique identifier for this API request.","schema":{"type":"string","description":"The unique identifier for this API request.","example":"req_1234567abcdefg"}}},"content":{"application/json":{"schema":{"type":"object","properties":{"objectType":{"description":"The type of object. This value is always `\"list\"`.","example":"list","type":"string","const":"list","isRequired":true,"uniqueKey":"objectType","typeLabel":"string"},"url":{"type":"string","description":"The endpoint URL where this list can be accessed.","example":"/v1/quickbooks-desktop/customers","isRequired":true,"uniqueKey":"url","typeLabel":"string"},"data":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","description":"The unique identifier assigned by QuickBooks to this customer. This ID is unique across all customers but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"data.items.[INDEX].id","typeLabel":"string"},"objectType":{"description":"The type of object. This value is always `\"qbd_customer\"`.","example":"qbd_customer","type":"string","const":"qbd_customer","isRequired":true,"uniqueKey":"data.items.[INDEX].objectType","typeLabel":"string"},"createdAt":{"type":"string","description":"The date and time when this customer was created, in ISO 8601 format (YYYY-MM-DDThh:mm:ss±hh:mm), which QuickBooks Desktop interprets in the local timezone of the end-user's computer.","example":"2025-01-01T12:34:56.000Z","isRequired":true,"uniqueKey":"data.items.[INDEX].createdAt","typeLabel":"string"},"updatedAt":{"type":"string","description":"The date and time when this customer was last updated, in ISO 8601 format (YYYY-MM-DDThh:mm:ss±hh:mm), which QuickBooks Desktop interprets in the local timezone of the end-user's computer.","example":"2025-02-01T12:34:56.000Z","isRequired":true,"uniqueKey":"data.items.[INDEX].updatedAt","typeLabel":"string"},"revisionNumber":{"type":"string","description":"The current QuickBooks-assigned revision number of this customer object, which changes each time the object is modified. When updating this object, you must provide the most recent `revisionNumber` to ensure you're working with the latest data; otherwise, the update will return an error.","example":"1721172183","isRequired":true,"uniqueKey":"data.items.[INDEX].revisionNumber","typeLabel":"string"},"name":{"type":"string","description":"The case-insensitive name of this customer. Not guaranteed to be unique because it does not include the names of its hierarchical parent objects like `fullName` does. For example, two customers could both have the `name` \"Website Redesign Project\", but they could have unique `fullName` values, such as \"ABC Corporation:Website Redesign Project\" and \"Baker:Website Redesign Project\".","example":"Website Redesign Project","isRequired":true,"uniqueKey":"data.items.[INDEX].name","typeLabel":"string"},"fullName":{"type":"string","description":"The case-insensitive fully-qualified unique name of this customer, formed by combining the names of its hierarchical parent objects with its own `name`, separated by colons. For example, if a customer is under \"ABC Corporation\" and has the `name` \"Website Redesign Project\", its `fullName` would be \"ABC Corporation:Website Redesign Project\".\n\n**NOTE**: Unlike `name`, `fullName` is guaranteed to be unique across all customer objects. However, `fullName` can still be arbitrarily changed by the QuickBooks user when they modify the underlying `name` field.\n\n**IMPORTANT**: If this object is a job (i.e., a sub-customer), this value would likely be the job's `name` prefixed by the customer's `name`.","example":"ABC Corporation:Website Redesign Project","isRequired":true,"uniqueKey":"data.items.[INDEX].fullName","typeLabel":"string"},"isActive":{"type":"boolean","description":"Indicates whether this customer is active. Inactive objects are typically hidden from views and reports in QuickBooks. Defaults to `true`.","example":true,"isRequired":true,"uniqueKey":"data.items.[INDEX].isActive","typeLabel":"boolean"},"class":{"oneOf":[{"type":"object","description":"The customer's class. Classes can be used to categorize objects into meaningful segments, such as department, location, or type of work. In QuickBooks, class tracking is off by default.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Consulting"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"data.items.[INDEX].class.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"data.items.[INDEX].class.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].class.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"data.items.[INDEX].class.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"data.items.[INDEX].class.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].class.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"data.items.[INDEX].class.oneOf.0","typeLabel":"object"},{"type":"null","description":"The customer's class. Classes can be used to categorize objects into meaningful segments, such as department, location, or type of work. In QuickBooks, class tracking is off by default.","example":{"id":"80000001-1234567890","fullName":"Consulting"},"isRequired":true,"uniqueKey":"data.items.[INDEX].class.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].class","typeLabel":"object | null"},"parent":{"oneOf":[{"type":"object","description":"The parent customer one level above this one in the hierarchy. For example, if this customer has a `fullName` of \"ABC Corporation:Website Redesign Project\", its parent has a `fullName` of \"ABC Corporation\". If this customer is at the top level, this field will be `null`.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"ABC Corporation"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"data.items.[INDEX].parent.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"data.items.[INDEX].parent.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].parent.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"data.items.[INDEX].parent.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"data.items.[INDEX].parent.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].parent.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"data.items.[INDEX].parent.oneOf.0","typeLabel":"object"},{"type":"null","description":"The parent customer one level above this one in the hierarchy. For example, if this customer has a `fullName` of \"ABC Corporation:Website Redesign Project\", its parent has a `fullName` of \"ABC Corporation\". If this customer is at the top level, this field will be `null`.","example":{"id":"80000001-1234567890","fullName":"ABC Corporation"},"isRequired":true,"uniqueKey":"data.items.[INDEX].parent.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].parent","typeLabel":"object | null"},"sublevel":{"type":"number","description":"The depth level of this customer in the hierarchy. A top-level customer has a `sublevel` of 0; each subsequent sublevel increases this number by 1. For example, a customer with a `fullName` of \"ABC Corporation:Website Redesign Project\" would have a `sublevel` of 1. When `sublevel` is 0, this object is a customer; when `sublevel` is greater than 0, this object is typically a job (i.e., a sub-customer).","example":1,"isRequired":true,"uniqueKey":"data.items.[INDEX].sublevel","typeLabel":"number"},"companyName":{"oneOf":[{"type":"string","description":"The name of the company associated with this customer. This name is used on invoices, checks, and other forms.","example":"Acme Corporation","isRequired":true,"uniqueKey":"data.items.[INDEX].companyName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The name of the company associated with this customer. This name is used on invoices, checks, and other forms.","example":"Acme Corporation","isRequired":true,"uniqueKey":"data.items.[INDEX].companyName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].companyName","typeLabel":"string | null"},"salutation":{"oneOf":[{"type":"string","description":"The formal salutation title that precedes the name of the contact person for this customer, such as \"Mr.\", \"Ms.\", or \"Dr.\".","example":"Dr.","isRequired":true,"uniqueKey":"data.items.[INDEX].salutation.oneOf.0","typeLabel":"string"},{"type":"null","description":"The formal salutation title that precedes the name of the contact person for this customer, such as \"Mr.\", \"Ms.\", or \"Dr.\".","example":"Dr.","isRequired":true,"uniqueKey":"data.items.[INDEX].salutation.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].salutation","typeLabel":"string | null"},"firstName":{"oneOf":[{"type":"string","description":"The first name of the contact person for this customer.","example":"John","isRequired":true,"uniqueKey":"data.items.[INDEX].firstName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The first name of the contact person for this customer.","example":"John","isRequired":true,"uniqueKey":"data.items.[INDEX].firstName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].firstName","typeLabel":"string | null"},"middleName":{"oneOf":[{"type":"string","description":"The middle name of the contact person for this customer.","example":"A.","isRequired":true,"uniqueKey":"data.items.[INDEX].middleName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The middle name of the contact person for this customer.","example":"A.","isRequired":true,"uniqueKey":"data.items.[INDEX].middleName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].middleName","typeLabel":"string | null"},"lastName":{"oneOf":[{"type":"string","description":"The last name of the contact person for this customer.","example":"Doe","isRequired":true,"uniqueKey":"data.items.[INDEX].lastName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The last name of the contact person for this customer.","example":"Doe","isRequired":true,"uniqueKey":"data.items.[INDEX].lastName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].lastName","typeLabel":"string | null"},"jobTitle":{"oneOf":[{"type":"string","description":"The job title of the contact person for this customer.","example":"Purchasing Manager","isRequired":true,"uniqueKey":"data.items.[INDEX].jobTitle.oneOf.0","typeLabel":"string"},{"type":"null","description":"The job title of the contact person for this customer.","example":"Purchasing Manager","isRequired":true,"uniqueKey":"data.items.[INDEX].jobTitle.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].jobTitle","typeLabel":"string | null"},"billingAddress":{"oneOf":[{"type":"object","title":"The Address object","description":"The customer's billing address.","required":["line1","line2","line3","line4","line5","city","state","postalCode","country","note"],"x-conductor-object-type":"nested","properties":{"line1":{"oneOf":[{"type":"string","description":"The first line of the address (e.g., street, PO Box, or company name).","example":"Conductor Labs Inc.","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.line1.oneOf.0","typeLabel":"string"},{"type":"null","description":"The first line of the address (e.g., street, PO Box, or company name).","example":"Conductor Labs Inc.","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.line1.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.line1","typeLabel":"string | null"},"line2":{"oneOf":[{"type":"string","description":"The second line of the address, if needed (e.g., apartment, suite, unit, or building).","example":"540 Market St.","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.line2.oneOf.0","typeLabel":"string"},{"type":"null","description":"The second line of the address, if needed (e.g., apartment, suite, unit, or building).","example":"540 Market St.","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.line2.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.line2","typeLabel":"string | null"},"line3":{"oneOf":[{"type":"string","description":"The third line of the address, if needed.","example":"Suite 100","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.line3.oneOf.0","typeLabel":"string"},{"type":"null","description":"The third line of the address, if needed.","example":"Suite 100","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.line3.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.line3","typeLabel":"string | null"},"line4":{"oneOf":[{"type":"string","description":"The fourth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.line4.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fourth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.line4.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.line4","typeLabel":"string | null"},"line5":{"oneOf":[{"type":"string","description":"The fifth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.line5.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fifth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.line5.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.line5","typeLabel":"string | null"},"city":{"oneOf":[{"type":"string","description":"The city, district, suburb, town, or village name of the address.","example":"San Francisco","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.city.oneOf.0","typeLabel":"string"},{"type":"null","description":"The city, district, suburb, town, or village name of the address.","example":"San Francisco","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.city.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.city","typeLabel":"string | null"},"state":{"oneOf":[{"type":"string","description":"The state, county, province, or region name of the address.","example":"CA","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.state.oneOf.0","typeLabel":"string"},{"type":"null","description":"The state, county, province, or region name of the address.","example":"CA","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.state.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.state","typeLabel":"string | null"},"postalCode":{"oneOf":[{"type":"string","description":"The postal code or ZIP code of the address.","example":"94110","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.postalCode.oneOf.0","typeLabel":"string"},{"type":"null","description":"The postal code or ZIP code of the address.","example":"94110","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.postalCode.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.postalCode","typeLabel":"string | null"},"country":{"oneOf":[{"type":"string","description":"The country name of the address.","example":"United States","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.country.oneOf.0","typeLabel":"string"},{"type":"null","description":"The country name of the address.","example":"United States","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.country.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.country","typeLabel":"string | null"},"note":{"oneOf":[{"type":"string","description":"A note written at the bottom of the address in the form in which it appears, such as the invoice form.","example":"Conductor HQ","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.note.oneOf.0","typeLabel":"string"},{"type":"null","description":"A note written at the bottom of the address in the form in which it appears, such as the invoice form.","example":"Conductor HQ","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.note.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0.note","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.0","typeLabel":"The Address object · object"},{"type":"null","description":"The customer's billing address.","isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].billingAddress","typeLabel":"The Address object · object | null"},"shippingAddress":{"oneOf":[{"type":"object","title":"The Address object","description":"The customer's shipping address.","required":["line1","line2","line3","line4","line5","city","state","postalCode","country","note"],"x-conductor-object-type":"nested","properties":{"line1":{"oneOf":[{"type":"string","description":"The first line of the address (e.g., street, PO Box, or company name).","example":"Conductor Labs Inc.","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.line1.oneOf.0","typeLabel":"string"},{"type":"null","description":"The first line of the address (e.g., street, PO Box, or company name).","example":"Conductor Labs Inc.","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.line1.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.line1","typeLabel":"string | null"},"line2":{"oneOf":[{"type":"string","description":"The second line of the address, if needed (e.g., apartment, suite, unit, or building).","example":"540 Market St.","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.line2.oneOf.0","typeLabel":"string"},{"type":"null","description":"The second line of the address, if needed (e.g., apartment, suite, unit, or building).","example":"540 Market St.","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.line2.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.line2","typeLabel":"string | null"},"line3":{"oneOf":[{"type":"string","description":"The third line of the address, if needed.","example":"Suite 100","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.line3.oneOf.0","typeLabel":"string"},{"type":"null","description":"The third line of the address, if needed.","example":"Suite 100","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.line3.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.line3","typeLabel":"string | null"},"line4":{"oneOf":[{"type":"string","description":"The fourth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.line4.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fourth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.line4.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.line4","typeLabel":"string | null"},"line5":{"oneOf":[{"type":"string","description":"The fifth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.line5.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fifth line of the address, if needed.","example":"","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.line5.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.line5","typeLabel":"string | null"},"city":{"oneOf":[{"type":"string","description":"The city, district, suburb, town, or village name of the address.","example":"San Francisco","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.city.oneOf.0","typeLabel":"string"},{"type":"null","description":"The city, district, suburb, town, or village name of the address.","example":"San Francisco","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.city.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.city","typeLabel":"string | null"},"state":{"oneOf":[{"type":"string","description":"The state, county, province, or region name of the address.","example":"CA","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.state.oneOf.0","typeLabel":"string"},{"type":"null","description":"The state, county, province, or region name of the address.","example":"CA","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.state.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.state","typeLabel":"string | null"},"postalCode":{"oneOf":[{"type":"string","description":"The postal code or ZIP code of the address.","example":"94110","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.postalCode.oneOf.0","typeLabel":"string"},{"type":"null","description":"The postal code or ZIP code of the address.","example":"94110","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.postalCode.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.postalCode","typeLabel":"string | null"},"country":{"oneOf":[{"type":"string","description":"The country name of the address.","example":"United States","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.country.oneOf.0","typeLabel":"string"},{"type":"null","description":"The country name of the address.","example":"United States","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.country.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.country","typeLabel":"string | null"},"note":{"oneOf":[{"type":"string","description":"A note written at the bottom of the address in the form in which it appears, such as the invoice form.","example":"Conductor HQ","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.note.oneOf.0","typeLabel":"string"},{"type":"null","description":"A note written at the bottom of the address in the form in which it appears, such as the invoice form.","example":"Conductor HQ","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.note.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0.note","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.0","typeLabel":"The Address object · object"},{"type":"null","description":"The customer's shipping address.","isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].shippingAddress","typeLabel":"The Address object · object | null"},"alternateShippingAddresses":{"oneOf":[{"type":"array","items":{"type":"object","properties":{"name":{"oneOf":[{"type":"string","description":"The case-insensitive unique name of this shipping address, unique across all shipping addresses.\n\n**NOTE**: Shipping addresses do not have a `fullName` field because they are not hierarchical objects, which is why `name` is unique for them but not for objects that have parents.","example":"Alternate shipping address","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].name.oneOf.0","typeLabel":"string"},{"type":"null","description":"The case-insensitive unique name of this shipping address, unique across all shipping addresses.\n\n**NOTE**: Shipping addresses do not have a `fullName` field because they are not hierarchical objects, which is why `name` is unique for them but not for objects that have parents.","example":"Alternate shipping address","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].name.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].name","typeLabel":"string | null"},"line1":{"oneOf":[{"type":"string","description":"The first line of the shipping address (e.g., street, PO Box, or company name).","example":"Conductor Labs Inc.","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].line1.oneOf.0","typeLabel":"string"},{"type":"null","description":"The first line of the shipping address (e.g., street, PO Box, or company name).","example":"Conductor Labs Inc.","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].line1.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].line1","typeLabel":"string | null"},"line2":{"oneOf":[{"type":"string","description":"The second line of the shipping address, if needed (e.g., apartment, suite, unit, or building).","example":"540 Market St.","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].line2.oneOf.0","typeLabel":"string"},{"type":"null","description":"The second line of the shipping address, if needed (e.g., apartment, suite, unit, or building).","example":"540 Market St.","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].line2.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].line2","typeLabel":"string | null"},"line3":{"oneOf":[{"type":"string","description":"The third line of the shipping address, if needed.","example":"Suite 100","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].line3.oneOf.0","typeLabel":"string"},{"type":"null","description":"The third line of the shipping address, if needed.","example":"Suite 100","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].line3.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].line3","typeLabel":"string | null"},"line4":{"oneOf":[{"type":"string","description":"The fourth line of the shipping address, if needed.","example":"","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].line4.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fourth line of the shipping address, if needed.","example":"","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].line4.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].line4","typeLabel":"string | null"},"line5":{"oneOf":[{"type":"string","description":"The fifth line of the shipping address, if needed.","example":"","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].line5.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fifth line of the shipping address, if needed.","example":"","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].line5.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].line5","typeLabel":"string | null"},"city":{"oneOf":[{"type":"string","description":"The city, district, suburb, town, or village name of the shipping address.","example":"San Francisco","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].city.oneOf.0","typeLabel":"string"},{"type":"null","description":"The city, district, suburb, town, or village name of the shipping address.","example":"San Francisco","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].city.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].city","typeLabel":"string | null"},"state":{"oneOf":[{"type":"string","description":"The state, county, province, or region name of the shipping address.","example":"CA","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].state.oneOf.0","typeLabel":"string"},{"type":"null","description":"The state, county, province, or region name of the shipping address.","example":"CA","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].state.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].state","typeLabel":"string | null"},"postalCode":{"oneOf":[{"type":"string","description":"The postal code or ZIP code of the shipping address.","example":"94110","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].postalCode.oneOf.0","typeLabel":"string"},{"type":"null","description":"The postal code or ZIP code of the shipping address.","example":"94110","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].postalCode.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].postalCode","typeLabel":"string | null"},"country":{"oneOf":[{"type":"string","description":"The country name of the shipping address.","example":"United States","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].country.oneOf.0","typeLabel":"string"},{"type":"null","description":"The country name of the shipping address.","example":"United States","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].country.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].country","typeLabel":"string | null"},"note":{"oneOf":[{"type":"string","description":"A note written at the bottom of the shipping address in the form in which it appears, such as the invoice form.","example":"Conductor HQ","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].note.oneOf.0","typeLabel":"string"},{"type":"null","description":"A note written at the bottom of the shipping address in the form in which it appears, such as the invoice form.","example":"Conductor HQ","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].note.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].note","typeLabel":"string | null"},"isDefaultShippingAddress":{"oneOf":[{"type":"boolean","description":"Indicates whether this shipping address is the default shipping address.","example":true,"isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].isDefaultShippingAddress.oneOf.0","typeLabel":"boolean"},{"type":"null","description":"Indicates whether this shipping address is the default shipping address.","example":true,"isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].isDefaultShippingAddress.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX].isDefaultShippingAddress","typeLabel":"boolean | null"}},"required":["name","line1","line2","line3","line4","line5","city","state","postalCode","country","note","isDefaultShippingAddress"],"additionalProperties":false,"title":"The Shipping Address object","x-conductor-object-type":"nested","uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0.items.[INDEX]","typeLabel":"The Shipping Address object · object"},"description":"A list of additional shipping addresses for this customer. Useful when the customer has multiple shipping locations. If `excludeAlternateShippingAddresses=true` is set on a customer list request, this field is `null` because the addresses were not fetched.","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.0","typeLabel":"The Shipping Address object · object[]"},{"type":"null","description":"A list of additional shipping addresses for this customer. Useful when the customer has multiple shipping locations. If `excludeAlternateShippingAddresses=true` is set on a customer list request, this field is `null` because the addresses were not fetched.","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].alternateShippingAddresses","typeLabel":"The Shipping Address object · object[] | null"},"phone":{"oneOf":[{"type":"string","description":"The customer's primary telephone number.","example":"+1-555-123-4567","isRequired":true,"uniqueKey":"data.items.[INDEX].phone.oneOf.0","typeLabel":"string"},{"type":"null","description":"The customer's primary telephone number.","example":"+1-555-123-4567","isRequired":true,"uniqueKey":"data.items.[INDEX].phone.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].phone","typeLabel":"string | null"},"alternatePhone":{"oneOf":[{"type":"string","description":"The customer's alternate telephone number.","example":"+1-555-987-6543","isRequired":true,"uniqueKey":"data.items.[INDEX].alternatePhone.oneOf.0","typeLabel":"string"},{"type":"null","description":"The customer's alternate telephone number.","example":"+1-555-987-6543","isRequired":true,"uniqueKey":"data.items.[INDEX].alternatePhone.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].alternatePhone","typeLabel":"string | null"},"fax":{"oneOf":[{"type":"string","description":"The customer's fax number.","example":"+1-555-555-1212","isRequired":true,"uniqueKey":"data.items.[INDEX].fax.oneOf.0","typeLabel":"string"},{"type":"null","description":"The customer's fax number.","example":"+1-555-555-1212","isRequired":true,"uniqueKey":"data.items.[INDEX].fax.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].fax","typeLabel":"string | null"},"email":{"oneOf":[{"type":"string","description":"The customer's email address.","example":"customer@example.com","isRequired":true,"uniqueKey":"data.items.[INDEX].email.oneOf.0","typeLabel":"string"},{"type":"null","description":"The customer's email address.","example":"customer@example.com","isRequired":true,"uniqueKey":"data.items.[INDEX].email.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].email","typeLabel":"string | null"},"ccEmail":{"oneOf":[{"type":"string","description":"An email address to carbon copy (CC) on communications with this customer.","example":"manager@example.com","isRequired":true,"uniqueKey":"data.items.[INDEX].ccEmail.oneOf.0","typeLabel":"string"},{"type":"null","description":"An email address to carbon copy (CC) on communications with this customer.","example":"manager@example.com","isRequired":true,"uniqueKey":"data.items.[INDEX].ccEmail.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].ccEmail","typeLabel":"string | null"},"contact":{"oneOf":[{"type":"string","description":"The name of the primary contact person for this customer.","example":"Jane Smith","isRequired":true,"uniqueKey":"data.items.[INDEX].contact.oneOf.0","typeLabel":"string"},{"type":"null","description":"The name of the primary contact person for this customer.","example":"Jane Smith","isRequired":true,"uniqueKey":"data.items.[INDEX].contact.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].contact","typeLabel":"string | null"},"alternateContact":{"oneOf":[{"type":"string","description":"The name of a alternate contact person for this customer.","example":"Bob Johnson","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateContact.oneOf.0","typeLabel":"string"},{"type":"null","description":"The name of a alternate contact person for this customer.","example":"Bob Johnson","isRequired":true,"uniqueKey":"data.items.[INDEX].alternateContact.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].alternateContact","typeLabel":"string | null"},"customContactFields":{"type":"array","items":{"type":"object","properties":{"name":{"type":"string","description":"The name of the contact field (e.g., \"old address\", \"secondary phone\").","example":"Main Phone","isRequired":true,"uniqueKey":"data.items.[INDEX].customContactFields.items.[INDEX].name","typeLabel":"string"},"value":{"oneOf":[{"type":"string","description":"The value of the contact field.","example":"555-123-4567","isRequired":true,"uniqueKey":"data.items.[INDEX].customContactFields.items.[INDEX].value.oneOf.0","typeLabel":"string"},{"type":"null","description":"The value of the contact field.","example":"555-123-4567","isRequired":true,"uniqueKey":"data.items.[INDEX].customContactFields.items.[INDEX].value.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].customContactFields.items.[INDEX].value","typeLabel":"string | null"}},"required":["name","value"],"additionalProperties":false,"title":"The Custom Contact Field object","x-conductor-object-type":"nested","uniqueKey":"data.items.[INDEX].customContactFields.items.[INDEX]","typeLabel":"The Custom Contact Field object · object"},"description":"Additional custom contact fields for this customer, such as phone numbers or email addresses.","isRequired":true,"uniqueKey":"data.items.[INDEX].customContactFields","typeLabel":"The Custom Contact Field object · object[]"},"additionalContacts":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","description":"The unique identifier assigned by QuickBooks to this contact. This ID is unique across all contacts but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].id","typeLabel":"string"},"objectType":{"description":"The type of object. This value is always `\"qbd_contact\"`.","example":"qbd_contact","type":"string","const":"qbd_contact","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].objectType","typeLabel":"string"},"createdAt":{"type":"string","description":"The date and time when this contact was created, in ISO 8601 format (YYYY-MM-DDThh:mm:ss±hh:mm), which QuickBooks Desktop interprets in the local timezone of the end-user's computer.","example":"2025-01-01T12:34:56.000Z","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].createdAt","typeLabel":"string"},"updatedAt":{"type":"string","description":"The date and time when this contact was last updated, in ISO 8601 format (YYYY-MM-DDThh:mm:ss±hh:mm), which QuickBooks Desktop interprets in the local timezone of the end-user's computer.","example":"2025-02-01T12:34:56.000Z","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].updatedAt","typeLabel":"string"},"revisionNumber":{"type":"string","description":"The current QuickBooks-assigned revision number of this contact object, which changes each time the object is modified. When updating this object, you must provide the most recent `revisionNumber` to ensure you're working with the latest data; otherwise, the update will return an error.","example":"1721172183","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].revisionNumber","typeLabel":"string"},"name":{"oneOf":[{"type":"string","description":"The contact's full name.","example":"Jane Smith","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].name.oneOf.0","typeLabel":"string"},{"type":"null","description":"The contact's full name.","example":"Jane Smith","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].name.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].name","typeLabel":"string | null"},"salutation":{"oneOf":[{"type":"string","description":"The contact's formal salutation title that precedes their name, such as \"Mr.\", \"Ms.\", or \"Dr.\".","example":"Dr.","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].salutation.oneOf.0","typeLabel":"string"},{"type":"null","description":"The contact's formal salutation title that precedes their name, such as \"Mr.\", \"Ms.\", or \"Dr.\".","example":"Dr.","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].salutation.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].salutation","typeLabel":"string | null"},"firstName":{"type":"string","description":"The contact's first name.","example":"John","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].firstName","typeLabel":"string"},"middleName":{"oneOf":[{"type":"string","description":"The contact's middle name.","example":"A.","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].middleName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The contact's middle name.","example":"A.","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].middleName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].middleName","typeLabel":"string | null"},"lastName":{"oneOf":[{"type":"string","description":"The contact's last name.","example":"Doe","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].lastName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The contact's last name.","example":"Doe","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].lastName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].lastName","typeLabel":"string | null"},"jobTitle":{"oneOf":[{"type":"string","description":"The contact's job title.","example":"Purchasing Manager","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].jobTitle.oneOf.0","typeLabel":"string"},{"type":"null","description":"The contact's job title.","example":"Purchasing Manager","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].jobTitle.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].jobTitle","typeLabel":"string | null"},"customContactFields":{"type":"array","items":{"type":"object","properties":{"name":{"type":"string","description":"The name of the contact field (e.g., \"old address\", \"secondary phone\").","example":"Main Phone","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].customContactFields.items.[INDEX].name","typeLabel":"string"},"value":{"oneOf":[{"type":"string","description":"The value of the contact field.","example":"555-123-4567","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].customContactFields.items.[INDEX].value.oneOf.0","typeLabel":"string"},{"type":"null","description":"The value of the contact field.","example":"555-123-4567","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].customContactFields.items.[INDEX].value.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].customContactFields.items.[INDEX].value","typeLabel":"string | null"}},"required":["name","value"],"additionalProperties":false,"title":"The Custom Contact Field object","x-conductor-object-type":"nested","uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].customContactFields.items.[INDEX]","typeLabel":"The Custom Contact Field object · object"},"description":"Additional custom contact fields for this contact, such as phone numbers or email addresses.","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX].customContactFields","typeLabel":"The Custom Contact Field object · object[]"}},"required":["id","objectType","createdAt","updatedAt","revisionNumber","name","salutation","firstName","middleName","lastName","jobTitle","customContactFields"],"additionalProperties":false,"title":"The Contact object","x-conductor-object-type":"nested","uniqueKey":"data.items.[INDEX].additionalContacts.items.[INDEX]","typeLabel":"The Contact object · object"},"description":"Additional alternate contacts for this customer.","isRequired":true,"uniqueKey":"data.items.[INDEX].additionalContacts","typeLabel":"The Contact object · object[]"},"customerType":{"oneOf":[{"type":"object","description":"The customer's type, used for categorizing customers into meaningful segments, such as industry or region.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Retail Customer"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"data.items.[INDEX].customerType.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"data.items.[INDEX].customerType.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].customerType.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"data.items.[INDEX].customerType.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"data.items.[INDEX].customerType.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].customerType.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"data.items.[INDEX].customerType.oneOf.0","typeLabel":"object"},{"type":"null","description":"The customer's type, used for categorizing customers into meaningful segments, such as industry or region.","example":{"id":"80000001-1234567890","fullName":"Retail Customer"},"isRequired":true,"uniqueKey":"data.items.[INDEX].customerType.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].customerType","typeLabel":"object | null"},"terms":{"oneOf":[{"type":"object","description":"The customer's payment terms, defining when payment is due and any applicable discounts.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Net 30"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"data.items.[INDEX].terms.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"data.items.[INDEX].terms.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].terms.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"data.items.[INDEX].terms.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"data.items.[INDEX].terms.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].terms.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"data.items.[INDEX].terms.oneOf.0","typeLabel":"object"},{"type":"null","description":"The customer's payment terms, defining when payment is due and any applicable discounts.","example":{"id":"80000001-1234567890","fullName":"Net 30"},"isRequired":true,"uniqueKey":"data.items.[INDEX].terms.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].terms","typeLabel":"object | null"},"salesRepresentative":{"oneOf":[{"type":"object","description":"The customer's sales representative. Sales representatives can be employees, vendors, or other names in QuickBooks.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Jane Doe"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"data.items.[INDEX].salesRepresentative.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"data.items.[INDEX].salesRepresentative.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].salesRepresentative.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"data.items.[INDEX].salesRepresentative.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"data.items.[INDEX].salesRepresentative.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].salesRepresentative.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"data.items.[INDEX].salesRepresentative.oneOf.0","typeLabel":"object"},{"type":"null","description":"The customer's sales representative. Sales representatives can be employees, vendors, or other names in QuickBooks.","example":{"id":"80000001-1234567890","fullName":"Jane Doe"},"isRequired":true,"uniqueKey":"data.items.[INDEX].salesRepresentative.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].salesRepresentative","typeLabel":"object | null"},"balance":{"oneOf":[{"type":"string","description":"The current balance owed by this customer, excluding balances from any jobs (i.e., sub-customers), represented as a decimal string. Compare with `totalBalance`. A positive number indicates money owed by the customer.","example":"1000.00","isRequired":true,"uniqueKey":"data.items.[INDEX].balance.oneOf.0","typeLabel":"string"},{"type":"null","description":"The current balance owed by this customer, excluding balances from any jobs (i.e., sub-customers), represented as a decimal string. Compare with `totalBalance`. A positive number indicates money owed by the customer.","example":"1000.00","isRequired":true,"uniqueKey":"data.items.[INDEX].balance.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].balance","typeLabel":"string | null"},"totalBalance":{"oneOf":[{"type":"string","description":"The combined balance of this customer and all of this customer's jobs (i.e., sub-customers), represented as a decimal string. If there are no sub-customers, `totalBalance` and `balance` are equal. A positive number indicates money owed by the customer.","example":"5000.00","isRequired":true,"uniqueKey":"data.items.[INDEX].totalBalance.oneOf.0","typeLabel":"string"},{"type":"null","description":"The combined balance of this customer and all of this customer's jobs (i.e., sub-customers), represented as a decimal string. If there are no sub-customers, `totalBalance` and `balance` are equal. A positive number indicates money owed by the customer.","example":"5000.00","isRequired":true,"uniqueKey":"data.items.[INDEX].totalBalance.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].totalBalance","typeLabel":"string | null"},"salesTaxCode":{"oneOf":[{"type":"object","description":"The default sales-tax code for transactions with this customer, determining whether the transactions are taxable or non-taxable. This can be overridden at the transaction or transaction-line level.\n\nDefault codes include \"Non\" (non-taxable) and \"Tax\" (taxable), but custom codes can also be created in QuickBooks Desktop. If QuickBooks Desktop is not set up to charge sales tax (via the \"Do You Charge Sales Tax?\" preference), it assigns the default non-taxable sales-tax code configured in the company file to all sales.","required":["id","fullName"],"example":{"id":"80000001-1234567890","fullName":"Non"},"properties":{"id":{"oneOf":[{"type":"string","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"data.items.[INDEX].salesTaxCode.oneOf.0.id.oneOf.0","typeLabel":"string"},{"type":"null","description":"The unique identifier assigned by QuickBooks to this object. This ID is unique across all objects of the same type, but not across different QuickBooks object types.","example":"80000001-1234567890","isRequired":true,"uniqueKey":"data.items.[INDEX].salesTaxCode.oneOf.0.id.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].salesTaxCode.oneOf.0.id","typeLabel":"string | null"},"fullName":{"oneOf":[{"type":"string","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"data.items.[INDEX].salesTaxCode.oneOf.0.fullName.oneOf.0","typeLabel":"string"},{"type":"null","description":"The fully-qualified unique name for this object, formed by combining the names of its parent objects with its own `name`, separated by colons. Not case-sensitive.","example":"Parent:Child:Grandchild","isRequired":true,"uniqueKey":"data.items.[INDEX].salesTaxCode.oneOf.0.fullName.oneOf.1","typeLabel":"null"}],"isRequired":true,"uniqueKey":"data.items.[INDEX].salesTaxCode.oneOf.0.fullName","typeLabel":"string | null"}},"additionalProperties":false,"isRequired":true,"uniqueKey":"data.items.[INDEX].salesTaxCode.oneOf.0","typeLabel":"object"},{"type":"null","description":"The default sales-tax code for transactions with this customer, determining whether the transactions are taxable or non-taxable. This can be overridden at the transaction or transaction-line level.\n\nDefault codes include \"Non\" (non-taxable) and \"Tax\" (taxable), but custom codes can also be created in QuickBooks Desktop. If QuickBooks Desktop is not set up to charge sales tax (via the \"Do You Charge Sales Tax?\" preference), it assigns the default non-taxable sales-tax code configured in the company file to all sales.","example":{"id":"800
[...]
